#define OPTIMIZE_ROM_CALLS
#define SAVE_SCREEN
#include <tigcclib.h>

short _ti89;
short _ti92plus;

int name[17];
int length = 0;

int choose(int x, int y, int w, int h, int spacing, int number, int current)
{
	int count;	//Used for FOR loops
	int z;		//Used for getting input
	for(;;)
	{
		z = 0;
		for(count = 0; count < h; count++)
			DrawLine(x, y+count+(current-1)*spacing, x+w, y+count+(current-1)*spacing, A_XOR);
		while(z != 264 && z != 13 && z != 337 && z != 340)
			z = ngetchx();
		if(z == 264) return 0;
		if(z == 13) 
		{
			for(count = 0; count < h; count++)
				DrawLine(x, y+count+(current-1)*spacing, x+w, y+count+(current-1)*spacing, A_XOR);
			return current;
		}
		for(count = 0; count < h; count++)
			DrawLine(x, y+count+(current-1)*spacing, x+w, y+count+(current-1)*spacing, A_XOR);
		if(z == 337)
		{
			current -= 1;
			if(current < 1) current = 1;
		}
		if(z == 340)
		{
			current += 1;
			if(current > number) current = number;
		}
	}
}

int InputStr(int x, int y, int max)
{
	int i = 0;
	int z = 0;
	int c;
	for(c = 0; c < max; c++) name[c] = 32;
	printf_xy(x, y, "_");
   for(;;)
   {
   	z = ngetchx();
   	if(z == 13) break;
   	if(z == 257 && i > 0) 
   	{
   		i--;
   		name[i] = 32;
   		printf_xy(x + i*6, y, "_ ");
   	}
   	if(z != 257 && i < max)
   	{
   		name[i] = z;
   		printf_xy(x + i*6, y, "%c_ ", name[i]);
   		i++;
   	}
   }
   return i;
}

void menu(int x, int y, int w, int h, int m)
{
	int z;
	//Center the screen
	if(m == 1)
	{
		x = LCD_WIDTH/2 - w/2;
		y = LCD_HEIGHT/2 - h/2;
	}
	//Clear the area
	for(z = 0; z < h; z++)
		DrawLine(x, y+z, x+w, y+z, A_REVERSE);
	//Draw outside layer
	DrawLine(x+1, y, x+w-2, y, A_NORMAL);
	DrawLine(x+1, y+h-1, x+w-1, y+h-1, A_NORMAL);
	DrawLine(x, y+1, x, y+h-2, A_NORMAL);
	DrawLine(x+w-1, y+1, x+w-1, y+h-2, A_NORMAL);
	//Draw outside shadow
	DrawLine(x+2, y+h, x+w-1, y+h, A_NORMAL);
	DrawLine(x+w, y+2, x+w, y+h-1, A_NORMAL);
	//Draw inside layer
	DrawLine(x+2, y+2, x+w-3, y+2, A_NORMAL);
	DrawLine(x+2, y+h-3, x+w-3, y+h-3, A_NORMAL);
	DrawLine(x+2, y+2, x+2, y+h-3, A_NORMAL);
	DrawLine(x+w-3, y+2, x+w-3, y+h-3, A_NORMAL);
	//Draw inside shadow
	DrawLine(x+2, y+3, x+w-3, y+3, A_NORMAL);
	DrawLine(x+3, y+2, x+3, y+h-3, A_NORMAL);
}

void _main(void)
{
	int x, z;
	char y[16];
	GrayMode(GRAY_OFF);
	menu(0,0,73,41,1);
	FontSetSys(F_4x6);
	DrawStr(52, 39, "New Background", A_NORMAL);
	DrawStr(56, 49, "Background On", A_NORMAL);
	DrawStr(55, 59, "Background Off", A_NORMAL);
	x = choose(50, 36, 61, 10, 10, 3,1);
	switch(x)
	{
		case 1:
			menu(0,0,130,25,1);
			FontSetSys(F_6x8);
			length = InputStr(25,48,17);
		case 2:
			for(z = 0; z < 17; z++)
				y[z] = (char)name[z];
			GrayMode(GRAY_ON);
			SetPlane(LIGHT_PLANE);
			clrscr();
			FontSetSys(F_8x10);
			DrawStr(LCD_WIDTH/2 - length*8/2, LCD_HEIGHT/2 - 10/2, y, A_NORMAL);
			SetPlane(DARK_PLANE);
			clrscr();
			break;
		case 3:
			GrayMode(GRAY_OFF);
			break;
	}
	return;
}
